/// <reference path="./Constants.js" />
/// <reference path="./logout.js" />

var refreshToken = (function () {
	'use strict';

	var refreshToken = {};

   function getRefreshToken() {
    return new Promise(function(resolve, reject) {
        var headers = {
            'Content-Type': 'application/json; charset=UTF-8',
            'Accept': 'application/json, text/javascript, */*; q=0.01',
        };
        headers['refreshToken'] = localStorage.getItem('refreshTokenRB');
        headers['Authorization'] = "Bearer " + sessionStorage.getItem('tokenRB');
        var serviceUrl = config.fundwaveIdBaseUrl + "token/refresh";
    
         $.ajax({
            type: "GET",
            headers: headers,
            dataType: "json",
            crossDomain: true,
            url: serviceUrl,
            success: function (data) {
                if (data) {
                    let token = data['token'];
                    let refreshToken = data['refreshToken'];
                    if (token) {
                        sessionStorage.setItem('tokenRB', token);
                    }
                    if (refreshToken) {
                        localStorage.setItem('refreshTokenRB', refreshToken);
                    }
                }
                resolve(sessionStorage.getItem('tokenRB'))
            },
    
            error: function (XMLHttpRequest, textStatus, errorThrown) {
                // window.location = "logout.html";
                if(XMLHttpRequest.status === 403){
                    logoutStorage();
                    reject(403)
                }
                else{
                    reject(500)
                }
                
                
                // return "expired"
                
    
            }
    
        });
    })
    


}

refreshToken.getAuthorizationHeader =  function (){
    return new Promise(function(resolve, reject) {
    if(localStorage.loginTypeRB ==="sso"){

        try{
            var result;
            if (sessionStorage.getItem('tokenRB')) {
                var details = JSON.parse(atob(sessionStorage.tokenRB.split('.')[1])); 
                if (details.exp < (new Date().getTime() + 1) / 1000) {
                   result =  getRefreshToken();
                }
            }
            else {
                result = getRefreshToken();
            }
            
            }
            catch(e){
                console.log(e)
            }
            if(result){
                result.then(function(){
                    resolve("Bearer "+sessionStorage.getItem('tokenRB'));
                },function(err){
                    if(err===403)
                        resolve(err)
                    else
                        resolve("Bearer "+sessionStorage.getItem('tokenRB'));
                })
            }
            else{
                resolve("Bearer "+sessionStorage.getItem('tokenRB'))
            }
            
            
            
            
    }
    else {
        if(sessionStorage.getItem('tokenRB')){
            resolve("Basic " + sessionStorage.getItem('tokenRB'));
        }
        else{
            logoutStorage();
            resolve(403);
        }
        
    }
})
}
    

	return refreshToken;
})();

