/// <reference path="../App.js" />	
/// <reference path="./Constants.js" />
/// <reference path="./refreshToken.js"/>

var fundwaveIdBaseUrl = config.fundwaveIdBaseUrl;
var dialog = null;
var userURL = "/services/api/user";

$(function () {
  $(window).load(function () {
    app.initialize(); //important to load the m/s apis

    detectBrowser();


    if (localStorage.getItem("loginTypeRB") === "sso") {
      $("#basicLoginForm").hide();
      $("#ssoLoginForm").show();
    }
    else {
      
        $("#basicLoginForm").show();
        $("#ssoLoginForm").hide();
      }
    });
});



function detectBrowser() {

  "use strict";

  // Detecting IE

  var oldIE = false;
  if ($('html').is('.ie6, .ie7, .ie8, .ie9')) {
    oldIE = true;
  }

  if (oldIE) {
    window.location = "Error.html";
  }


}

function processMessage(arg) {
  var data;
  
  if (Office.context.ui !== undefined) {
    dialog.close();
    data = JSON.parse(arg.message);

  }
  else {
    data = JSON.parse(arg.data);
  }
  // console.log(data)
  // console.log(arg)
  // showNotification(arg.message);
  if (data === "invalid") {
    app.showNotification("User not eligible", '');
  }
  else if (data.statusCode === 500) {
    app.showNotification("ERROR!! Contact Administrator.", '');
  }

  else if (data.type === "login-fundwave") {
    try {

      var token =data.token
      sessionStorage.setItem('tokenRB', token['id_token']);
      localStorage.setItem('refreshTokenRB', token['refresh_token']);
      console.log("login success")
      checkUserValidity();
      // window.location = "Main.html"
      

    }
    catch (err) {
      console.log(err)
    }
  }


}

function openAuthUri() {


  // utils.showloader(true);
  // var serviceUserUrl = Config.baseUrl + Config.serviceUrls.getUserAuthUrl+"?redirectOrigin="+window.location.origin+"&redirectUri="+Config.loginRedirect;
  
  var serviceUserUrl = config.baseHomeUrl + "auth/authLogin.html";
  if (Office.context.ui !== undefined) {
    Office.context.ui.displayDialogAsync(serviceUserUrl, { height: 65, width: 20 },

      function (asyncResult) {
        dialog = asyncResult.value;
        dialog.addEventHandler(Office.EventType.DialogMessageReceived, processMessage);
      }
    );
  }
  else {
    window.addEventListener('message', processMessage)
    window.open(serviceUserUrl, "AuthPopup",
      "scrollbars=yes,width=660,height=500,centerscreen=1");
  }
}

function backToServiceUrl (){
  window.location = "serviceUrl.html"
}


function basicAuthentication() {

	$('#notification-message').hide();

	var inputURL = localStorage.getItem("baseUrl")

	var serviceURL = inputURL + userURL;

	if (inputURL !== "https://") localStorage.setItem("baseUrl", inputURL);

	var userName = $("#uname").val().trim();

	var passWord = $("#pwd").val().trim();

	if (userName === "") {
		app.showNotification("Please enter the user name", '');
		return;
	} else if (passWord === "") {
		app.showNotification("Please enter the password", '');
		return;
	}

	$(".home-page").hide();
	$("#loading-icon").addClass("loading-icon");

	$("#loginIcon").removeClass();

	$("#loginIcon").addClass('glyphicon glyphicon-cog spin');

	var basicAuth = make_base_auth(userName, passWord);
	customStorage = basicAuth;

	$.support.cors = true;

	$.ajax({
		type: "GET",
		headers: {          
			Accept: "application/json; charset=utf-8",         
			"Content-Type": "application/json; charset=utf-8"   
		  }, 
		dataType: "json",

		crossDomain: true,
		url: serviceURL,
		beforeSend: function(xhr) {
			xhr.setRequestHeader("Authorization", "Basic " + basicAuth);
		},
		success: function(data) {
			$("#loading-icon").removeClass("loading-icon");
			$(".home-page").hide();
			$(".wrapper-class").show();
      // loadMainPage();
      localStorage.setItem("validUserRB",true);
      sessionStorage.setItem("tokenRB",basicAuth)
      localStorage.setItem("usernameRB",data.userName)
      window.location = "Main.html"
			// document.getElementById("loginForm").submit();
		},

		error: function(XMLHttpRequest, textStatus, errorThrown) {
			$(".home-page").show();
			$("#loading-icon").removeClass("loading-icon");

			app.showNotification("Error : ", "Unable to login. Please enter correct credentials.");
			$("#loginIcon").removeClass();
			$("#loginIcon").addClass('glyphicon glyphicon-log-in');



		}

	});

}


function make_base_auth(user, pass) {
  var tok = user + ':' + pass;

  var hash = $.base64.encode(tok);
  return  hash;

}

function checkUserValidity (){



    var fundName, id;
    var serviceURL = localStorage.getItem("baseUrl") + userURL;
    refreshToken.getAuthorizationHeader().then(function (basicAuth) {
    if(basicAuth ===403){
      return;
    }
  
    $.support.cors = true;
  
    $.ajax({
      type: "GET",
      headers: {
        Accept: "application/json; charset=utf-8",
        "Content-Type": "application/json; charset=utf-8"
      },
      dataType: "json",
      crossDomain: true,
      url: serviceURL,
      beforeSend: function (xhr) {
        xhr.setRequestHeader("Authorization", basicAuth);
      },
      success: function (data) {
        localStorage.setItem("validUserRB",true);
        localStorage.setItem("usernameRB",data.userName)
        window.location = "Main.html"
      },
      error: function (XMLHttpRequest, textStatus, errorThrown) {
  
        // app.showNotification('Could not retrieve funds ', errorThrown + ' : ' + textStatus);
        if(XMLHttpRequest.status===401){
          localStorage.setItem("validUserRB",false);
          window.location = "Main.html"
        }
        else {
          app.showNotification("Error : ", "Unable to login.");
        }
        
  
  
      }
  
    });
  })
  
  
}